package cn.ibizlab.businesscentral.core.odoo_mail.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.odoo_mail.domain.Mail_activity_type;
import cn.ibizlab.businesscentral.core.odoo_mail.filter.Mail_activity_typeSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[Mail_activity_type] 服务对象接口
 */
public interface IMail_activity_typeService extends IService<Mail_activity_type>{

    boolean create(Mail_activity_type et) ;
    void createBatch(List<Mail_activity_type> list) ;
    boolean update(Mail_activity_type et) ;
    void updateBatch(List<Mail_activity_type> list) ;
    boolean remove(Long key) ;
    void removeBatch(Collection<Long> idList) ;
    Mail_activity_type get(Long key) ;
    Mail_activity_type getDraft(Mail_activity_type et) ;
    boolean checkKey(Mail_activity_type et) ;
    boolean save(Mail_activity_type et) ;
    void saveBatch(List<Mail_activity_type> list) ;
    Page<Mail_activity_type> searchDefault(Mail_activity_typeSearchContext context) ;
    List<Mail_activity_type> selectByDefaultNextTypeId(Long id);
    void resetByDefaultNextTypeId(Long id);
    void resetByDefaultNextTypeId(Collection<Long> ids);
    void removeByDefaultNextTypeId(Long id);
    List<Mail_activity_type> selectByCreateUid(Long id);
    void removeByCreateUid(Long id);
    List<Mail_activity_type> selectByWriteUid(Long id);
    void removeByWriteUid(Long id);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<Mail_activity_type> getMailActivityTypeByIds(List<Long> ids) ;
    List<Mail_activity_type> getMailActivityTypeByEntities(List<Mail_activity_type> entities) ;
}


